/**
 * POCDMT000040Supply.java
 *
 * File generated from the cdaepsos3::POCDMT000040Supply uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos4;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.ArrayList;
import java.util.List;

// End of user code


/**
 * Description of the class POCDMT000040Supply.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.Supply", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"text",
	"statusCode",
	"effectiveTime",
	"priorityCode",
	"repeatNumber",
	"independentInd",
	"quantity",
	"expectedUseTime",
	"subject",
	"specimen",
	"product",
	"performer",
	"author",
	"informant",
	"participant",
	"entryRelationship",
	"reference",
	"precondition",
	"classCode",
	"moodCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.Supply")
public class POCDMT000040Supply implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "id", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> id;
	@XmlElement(name = "code", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CD code;
	@XmlElement(name = "text", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.ED text;
	@XmlElement(name = "statusCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CS statusCode;
	@XmlElement(name = "effectiveTime", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.SXCMTS> effectiveTime;
	@XmlElement(name = "priorityCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CE> priorityCode;
	@XmlElement(name = "repeatNumber", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.IVLINT repeatNumber;
	@XmlElement(name = "independentInd", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.BL independentInd;
	@XmlElement(name = "quantity", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.PQ quantity;
	@XmlElement(name = "expectedUseTime", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.IVLTS expectedUseTime;
	@XmlElement(name = "subject", namespace = "urn:hl7-org:v3")
	public POCDMT000040Subject subject;
	@XmlElement(name = "specimen", namespace = "urn:hl7-org:v3")
	public List<POCDMT000040Specimen> specimen;
	@XmlElement(name = "product", namespace = "urn:hl7-org:v3")
	public POCDMT000040Product product;
	@XmlElement(name = "performer", namespace = "urn:hl7-org:v3")
	public List<POCDMT000040Performer2> performer;
	@XmlElement(name = "author", namespace = "urn:hl7-org:v3")
	public List<POCDMT000040Author> author;
	@XmlElement(name = "informant", namespace = "urn:hl7-org:v3")
	public List<POCDMT000040Informant12> informant;
	@XmlElement(name = "participant", namespace = "urn:hl7-org:v3")
	public List<POCDMT000040Participant2> participant;
	@XmlElement(name = "entryRelationship", namespace = "urn:hl7-org:v3")
	public List<POCDMT000040EntryRelationship> entryRelationship;
	@XmlElement(name = "reference", namespace = "urn:hl7-org:v3")
	public List<POCDMT000040Reference> reference;
	@XmlElement(name = "precondition", namespace = "urn:hl7-org:v3")
	public List<POCDMT000040Precondition> precondition;
	@XmlAttribute(name = "classCode", required = true)
	public net.ihe.gazelle.voc.ActClassSupply classCode;
	@XmlAttribute(name = "moodCode", required = true)
	public net.ihe.gazelle.voc.XDocumentSubstanceMood moodCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public List<net.ihe.gazelle.datatypes.II> getId() {
		if (id == null) {
	        id = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(List<net.ihe.gazelle.datatypes.II> id) {
	    this.id = id;
	}
	
	
	
	/**
	 * Add a id to the id collection.
	 * @param id_elt Element to add.
	 */
	public void addId(net.ihe.gazelle.datatypes.II id_elt) {
	    this.getId().add(id_elt);
	}
	
	/**
	 * Remove a id to the id collection.
	 * @param id_elt Element to remove
	 */
	public void removeId(net.ihe.gazelle.datatypes.II id_elt) {
	    this.getId().remove(id_elt);
	}
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.datatypes.CD getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.datatypes.CD code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return text.
	 * @return text
	 */
	public net.ihe.gazelle.datatypes.ED getText() {
	    return text;
	}
	
	/**
	 * Set a value to attribute text.
	 * @param text.
	 */
	public void setText(net.ihe.gazelle.datatypes.ED text) {
	    this.text = text;
	}
	
	
	
	
	/**
	 * Return statusCode.
	 * @return statusCode
	 */
	public net.ihe.gazelle.datatypes.CS getStatusCode() {
	    return statusCode;
	}
	
	/**
	 * Set a value to attribute statusCode.
	 * @param statusCode.
	 */
	public void setStatusCode(net.ihe.gazelle.datatypes.CS statusCode) {
	    this.statusCode = statusCode;
	}
	
	
	
	
	/**
	 * Return effectiveTime.
	 * @return effectiveTime
	 */
	public List<net.ihe.gazelle.datatypes.SXCMTS> getEffectiveTime() {
		if (effectiveTime == null) {
	        effectiveTime = new ArrayList<net.ihe.gazelle.datatypes.SXCMTS>();
	    }
	    return effectiveTime;
	}
	
	/**
	 * Set a value to attribute effectiveTime.
	 * @param effectiveTime.
	 */
	public void setEffectiveTime(List<net.ihe.gazelle.datatypes.SXCMTS> effectiveTime) {
	    this.effectiveTime = effectiveTime;
	}
	
	
	
	/**
	 * Add a effectiveTime to the effectiveTime collection.
	 * @param effectiveTime_elt Element to add.
	 */
	public void addEffectiveTime(net.ihe.gazelle.datatypes.SXCMTS effectiveTime_elt) {
	    this.getEffectiveTime().add(effectiveTime_elt);
	}
	
	/**
	 * Remove a effectiveTime to the effectiveTime collection.
	 * @param effectiveTime_elt Element to remove
	 */
	public void removeEffectiveTime(net.ihe.gazelle.datatypes.SXCMTS effectiveTime_elt) {
	    this.getEffectiveTime().remove(effectiveTime_elt);
	}
	
	/**
	 * Return priorityCode.
	 * @return priorityCode
	 */
	public List<net.ihe.gazelle.datatypes.CE> getPriorityCode() {
		if (priorityCode == null) {
	        priorityCode = new ArrayList<net.ihe.gazelle.datatypes.CE>();
	    }
	    return priorityCode;
	}
	
	/**
	 * Set a value to attribute priorityCode.
	 * @param priorityCode.
	 */
	public void setPriorityCode(List<net.ihe.gazelle.datatypes.CE> priorityCode) {
	    this.priorityCode = priorityCode;
	}
	
	
	
	/**
	 * Add a priorityCode to the priorityCode collection.
	 * @param priorityCode_elt Element to add.
	 */
	public void addPriorityCode(net.ihe.gazelle.datatypes.CE priorityCode_elt) {
	    this.getPriorityCode().add(priorityCode_elt);
	}
	
	/**
	 * Remove a priorityCode to the priorityCode collection.
	 * @param priorityCode_elt Element to remove
	 */
	public void removePriorityCode(net.ihe.gazelle.datatypes.CE priorityCode_elt) {
	    this.getPriorityCode().remove(priorityCode_elt);
	}
	
	/**
	 * Return repeatNumber.
	 * @return repeatNumber
	 */
	public net.ihe.gazelle.datatypes.IVLINT getRepeatNumber() {
	    return repeatNumber;
	}
	
	/**
	 * Set a value to attribute repeatNumber.
	 * @param repeatNumber.
	 */
	public void setRepeatNumber(net.ihe.gazelle.datatypes.IVLINT repeatNumber) {
	    this.repeatNumber = repeatNumber;
	}
	
	
	
	
	/**
	 * Return independentInd.
	 * @return independentInd
	 */
	public net.ihe.gazelle.datatypes.BL getIndependentInd() {
	    return independentInd;
	}
	
	/**
	 * Set a value to attribute independentInd.
	 * @param independentInd.
	 */
	public void setIndependentInd(net.ihe.gazelle.datatypes.BL independentInd) {
	    this.independentInd = independentInd;
	}
	
	
	
	
	/**
	 * Return quantity.
	 * @return quantity
	 */
	public net.ihe.gazelle.datatypes.PQ getQuantity() {
	    return quantity;
	}
	
	/**
	 * Set a value to attribute quantity.
	 * @param quantity.
	 */
	public void setQuantity(net.ihe.gazelle.datatypes.PQ quantity) {
	    this.quantity = quantity;
	}
	
	
	
	
	/**
	 * Return expectedUseTime.
	 * @return expectedUseTime
	 */
	public net.ihe.gazelle.datatypes.IVLTS getExpectedUseTime() {
	    return expectedUseTime;
	}
	
	/**
	 * Set a value to attribute expectedUseTime.
	 * @param expectedUseTime.
	 */
	public void setExpectedUseTime(net.ihe.gazelle.datatypes.IVLTS expectedUseTime) {
	    this.expectedUseTime = expectedUseTime;
	}
	
	
	
	
	/**
	 * Return subject.
	 * @return subject
	 */
	public POCDMT000040Subject getSubject() {
	    return subject;
	}
	
	/**
	 * Set a value to attribute subject.
	 * @param subject.
	 */
	public void setSubject(POCDMT000040Subject subject) {
	    this.subject = subject;
	}
	
	
	
	
	/**
	 * Return specimen.
	 * @return specimen
	 */
	public List<POCDMT000040Specimen> getSpecimen() {
		if (specimen == null) {
	        specimen = new ArrayList<POCDMT000040Specimen>();
	    }
	    return specimen;
	}
	
	/**
	 * Set a value to attribute specimen.
	 * @param specimen.
	 */
	public void setSpecimen(List<POCDMT000040Specimen> specimen) {
	    this.specimen = specimen;
	}
	
	
	
	/**
	 * Add a specimen to the specimen collection.
	 * @param specimen_elt Element to add.
	 */
	public void addSpecimen(POCDMT000040Specimen specimen_elt) {
	    this.getSpecimen().add(specimen_elt);
	}
	
	/**
	 * Remove a specimen to the specimen collection.
	 * @param specimen_elt Element to remove
	 */
	public void removeSpecimen(POCDMT000040Specimen specimen_elt) {
	    this.getSpecimen().remove(specimen_elt);
	}
	
	/**
	 * Return product.
	 * @return product
	 */
	public POCDMT000040Product getProduct() {
	    return product;
	}
	
	/**
	 * Set a value to attribute product.
	 * @param product.
	 */
	public void setProduct(POCDMT000040Product product) {
	    this.product = product;
	}
	
	
	
	
	/**
	 * Return performer.
	 * @return performer
	 */
	public List<POCDMT000040Performer2> getPerformer() {
		if (performer == null) {
	        performer = new ArrayList<POCDMT000040Performer2>();
	    }
	    return performer;
	}
	
	/**
	 * Set a value to attribute performer.
	 * @param performer.
	 */
	public void setPerformer(List<POCDMT000040Performer2> performer) {
	    this.performer = performer;
	}
	
	
	
	/**
	 * Add a performer to the performer collection.
	 * @param performer_elt Element to add.
	 */
	public void addPerformer(POCDMT000040Performer2 performer_elt) {
	    this.getPerformer().add(performer_elt);
	}
	
	/**
	 * Remove a performer to the performer collection.
	 * @param performer_elt Element to remove
	 */
	public void removePerformer(POCDMT000040Performer2 performer_elt) {
	    this.getPerformer().remove(performer_elt);
	}
	
	/**
	 * Return author.
	 * @return author
	 */
	public List<POCDMT000040Author> getAuthor() {
		if (author == null) {
	        author = new ArrayList<POCDMT000040Author>();
	    }
	    return author;
	}
	
	/**
	 * Set a value to attribute author.
	 * @param author.
	 */
	public void setAuthor(List<POCDMT000040Author> author) {
	    this.author = author;
	}
	
	
	
	/**
	 * Add a author to the author collection.
	 * @param author_elt Element to add.
	 */
	public void addAuthor(POCDMT000040Author author_elt) {
	    this.getAuthor().add(author_elt);
	}
	
	/**
	 * Remove a author to the author collection.
	 * @param author_elt Element to remove
	 */
	public void removeAuthor(POCDMT000040Author author_elt) {
	    this.getAuthor().remove(author_elt);
	}
	
	/**
	 * Return informant.
	 * @return informant
	 */
	public List<POCDMT000040Informant12> getInformant() {
		if (informant == null) {
	        informant = new ArrayList<POCDMT000040Informant12>();
	    }
	    return informant;
	}
	
	/**
	 * Set a value to attribute informant.
	 * @param informant.
	 */
	public void setInformant(List<POCDMT000040Informant12> informant) {
	    this.informant = informant;
	}
	
	
	
	/**
	 * Add a informant to the informant collection.
	 * @param informant_elt Element to add.
	 */
	public void addInformant(POCDMT000040Informant12 informant_elt) {
	    this.getInformant().add(informant_elt);
	}
	
	/**
	 * Remove a informant to the informant collection.
	 * @param informant_elt Element to remove
	 */
	public void removeInformant(POCDMT000040Informant12 informant_elt) {
	    this.getInformant().remove(informant_elt);
	}
	
	/**
	 * Return participant.
	 * @return participant
	 */
	public List<POCDMT000040Participant2> getParticipant() {
		if (participant == null) {
	        participant = new ArrayList<POCDMT000040Participant2>();
	    }
	    return participant;
	}
	
	/**
	 * Set a value to attribute participant.
	 * @param participant.
	 */
	public void setParticipant(List<POCDMT000040Participant2> participant) {
	    this.participant = participant;
	}
	
	
	
	/**
	 * Add a participant to the participant collection.
	 * @param participant_elt Element to add.
	 */
	public void addParticipant(POCDMT000040Participant2 participant_elt) {
	    this.getParticipant().add(participant_elt);
	}
	
	/**
	 * Remove a participant to the participant collection.
	 * @param participant_elt Element to remove
	 */
	public void removeParticipant(POCDMT000040Participant2 participant_elt) {
	    this.getParticipant().remove(participant_elt);
	}
	
	/**
	 * Return entryRelationship.
	 * @return entryRelationship
	 */
	public List<POCDMT000040EntryRelationship> getEntryRelationship() {
		if (entryRelationship == null) {
	        entryRelationship = new ArrayList<POCDMT000040EntryRelationship>();
	    }
	    return entryRelationship;
	}
	
	/**
	 * Set a value to attribute entryRelationship.
	 * @param entryRelationship.
	 */
	public void setEntryRelationship(List<POCDMT000040EntryRelationship> entryRelationship) {
	    this.entryRelationship = entryRelationship;
	}
	
	
	
	/**
	 * Add a entryRelationship to the entryRelationship collection.
	 * @param entryRelationship_elt Element to add.
	 */
	public void addEntryRelationship(POCDMT000040EntryRelationship entryRelationship_elt) {
	    this.getEntryRelationship().add(entryRelationship_elt);
	}
	
	/**
	 * Remove a entryRelationship to the entryRelationship collection.
	 * @param entryRelationship_elt Element to remove
	 */
	public void removeEntryRelationship(POCDMT000040EntryRelationship entryRelationship_elt) {
	    this.getEntryRelationship().remove(entryRelationship_elt);
	}
	
	/**
	 * Return reference.
	 * @return reference
	 */
	public List<POCDMT000040Reference> getReference() {
		if (reference == null) {
	        reference = new ArrayList<POCDMT000040Reference>();
	    }
	    return reference;
	}
	
	/**
	 * Set a value to attribute reference.
	 * @param reference.
	 */
	public void setReference(List<POCDMT000040Reference> reference) {
	    this.reference = reference;
	}
	
	
	
	/**
	 * Add a reference to the reference collection.
	 * @param reference_elt Element to add.
	 */
	public void addReference(POCDMT000040Reference reference_elt) {
	    this.getReference().add(reference_elt);
	}
	
	/**
	 * Remove a reference to the reference collection.
	 * @param reference_elt Element to remove
	 */
	public void removeReference(POCDMT000040Reference reference_elt) {
	    this.getReference().remove(reference_elt);
	}
	
	/**
	 * Return precondition.
	 * @return precondition
	 */
	public List<POCDMT000040Precondition> getPrecondition() {
		if (precondition == null) {
	        precondition = new ArrayList<POCDMT000040Precondition>();
	    }
	    return precondition;
	}
	
	/**
	 * Set a value to attribute precondition.
	 * @param precondition.
	 */
	public void setPrecondition(List<POCDMT000040Precondition> precondition) {
	    this.precondition = precondition;
	}
	
	
	
	/**
	 * Add a precondition to the precondition collection.
	 * @param precondition_elt Element to add.
	 */
	public void addPrecondition(POCDMT000040Precondition precondition_elt) {
	    this.getPrecondition().add(precondition_elt);
	}
	
	/**
	 * Remove a precondition to the precondition collection.
	 * @param precondition_elt Element to remove
	 */
	public void removePrecondition(POCDMT000040Precondition precondition_elt) {
	    this.getPrecondition().remove(precondition_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.ActClassSupply getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.ActClassSupply classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return moodCode.
	 * @return moodCode
	 */
	public net.ihe.gazelle.voc.XDocumentSubstanceMood getMoodCode() {
	    return moodCode;
	}
	
	/**
	 * Set a value to attribute moodCode.
	 * @param moodCode.
	 */
	public void setMoodCode(net.ihe.gazelle.voc.XDocumentSubstanceMood moodCode) {
	    this.moodCode = moodCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos4");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.Supply").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040Supply pOCDMT000040Supply, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040Supply != null){
   			cvm.validate(pOCDMT000040Supply, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040Supply.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040Supply.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040Supply.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II id: pOCDMT000040Supply.getId()){
					net.ihe.gazelle.datatypes.II.validateByModule(id, _location + "/id[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.CD.validateByModule(pOCDMT000040Supply.getCode(), _location + "/code", cvm, diagnostic);
			net.ihe.gazelle.datatypes.ED.validateByModule(pOCDMT000040Supply.getText(), _location + "/text", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CS.validateByModule(pOCDMT000040Supply.getStatusCode(), _location + "/statusCode", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.SXCMTS effectiveTime: pOCDMT000040Supply.getEffectiveTime()){
					net.ihe.gazelle.datatypes.SXCMTS.validateByModule(effectiveTime, _location + "/effectiveTime[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CE priorityCode: pOCDMT000040Supply.getPriorityCode()){
					net.ihe.gazelle.datatypes.CE.validateByModule(priorityCode, _location + "/priorityCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.IVLINT.validateByModule(pOCDMT000040Supply.getRepeatNumber(), _location + "/repeatNumber", cvm, diagnostic);
			net.ihe.gazelle.datatypes.BL.validateByModule(pOCDMT000040Supply.getIndependentInd(), _location + "/independentInd", cvm, diagnostic);
			net.ihe.gazelle.datatypes.PQ.validateByModule(pOCDMT000040Supply.getQuantity(), _location + "/quantity", cvm, diagnostic);
			net.ihe.gazelle.datatypes.IVLTS.validateByModule(pOCDMT000040Supply.getExpectedUseTime(), _location + "/expectedUseTime", cvm, diagnostic);
			POCDMT000040Subject.validateByModule(pOCDMT000040Supply.getSubject(), _location + "/subject", cvm, diagnostic);
			{
				int i = 0;
				for (POCDMT000040Specimen specimen: pOCDMT000040Supply.getSpecimen()){
					POCDMT000040Specimen.validateByModule(specimen, _location + "/specimen[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			POCDMT000040Product.validateByModule(pOCDMT000040Supply.getProduct(), _location + "/product", cvm, diagnostic);
			{
				int i = 0;
				for (POCDMT000040Performer2 performer: pOCDMT000040Supply.getPerformer()){
					POCDMT000040Performer2.validateByModule(performer, _location + "/performer[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (POCDMT000040Author author: pOCDMT000040Supply.getAuthor()){
					POCDMT000040Author.validateByModule(author, _location + "/author[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (POCDMT000040Informant12 informant: pOCDMT000040Supply.getInformant()){
					POCDMT000040Informant12.validateByModule(informant, _location + "/informant[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (POCDMT000040Participant2 participant: pOCDMT000040Supply.getParticipant()){
					POCDMT000040Participant2.validateByModule(participant, _location + "/participant[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (POCDMT000040EntryRelationship entryRelationship: pOCDMT000040Supply.getEntryRelationship()){
					POCDMT000040EntryRelationship.validateByModule(entryRelationship, _location + "/entryRelationship[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (POCDMT000040Reference reference: pOCDMT000040Supply.getReference()){
					POCDMT000040Reference.validateByModule(reference, _location + "/reference[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (POCDMT000040Precondition precondition: pOCDMT000040Supply.getPrecondition()){
					POCDMT000040Precondition.validateByModule(precondition, _location + "/precondition[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

    	}
    }

}